#include <stdio.h>
#include <string.h>
#include <s1c33cpu.h>

#include "d12ci.h"
#include "mainloop.h"
#include "usb100.h"
#include "chap_9.h"

/* foCXfBXNv^̋Lq́A
 * CQoŎ ebNAC uUSBn[h&\tgĴׂāv 
 * 5 USBXs[J[TvvO 炲蒸܂B
 */

extern CONTROL_XFER		ControlData;
extern EPPFLAGS			bEPPflags;

static unsigned char tmpbuff[4096];

#define PCE_VENDOR_ID		0x0e19
#define PCE_PRODUCT_ID_BASIC	0x1000	// {[h
#define PCE_PRODUCT_ID_GAMEPAD	0x1001	// GamePad [h
#define PCE_PRODUCT_ID_SPKR	0x1010	// Xs[J[[hiɎg܂(^^;j

//
//@foCXfBXNv^
//
unsigned char dev_desc[0x12]  = {
	0x12,		// bLength		: 0x12
	0x01,		// bDescriptorType	: 0x01   ifoCXEfBXNv^	j
	0x00, 0x01,	// bcdUSB		: 0x0100 iUSB Version 1.0		j
	0x00,		// bDeviceClass		: 0x00   ieC^[tF[Xɐݒ	j
	0x00,		// bDeviceSubClass	: 0x00   igp			j
	0x00,		// bDeviceProtocol	: 0x00   igp			j
	0x10,		// bMaxPacketSize0	: 0x10   iEP0̍őpPbgTCY	j
	0x19, 0x0e,	// idVendor		: 0x0e19 iPCE_VENDOR_ID		j
	0x10, 0x10,	// idProduct		: 0x1010 iPCE_PRODUCT_ID_SPKR		j
	0x01, 0x00,	// bcdDevice		: 0x0001 ifoCX[Xԍ		j
	0x00,		// iManufacture		: 0x00   igp			j
	0x00,		// iProduct		: 0x00@ igp			j
	0x00,		// iSerialNumber	: 0x00@ igp			j
	0x01		// bNumConfiguraions	: 0x01   iRtBO[V͂P	j
};

//
//@RtBO[VfBXNv^
//
unsigned char config_desc[9] = {
	0x09,		//  bLength		: 0x09
	0x02,		//  bDescriptorType	: 0x02	iRtBO[VEfBXNv^		j
	0x64, 0x00,	//  wTotalLength	: 100	iC^[tF[X^Gh|CgfBXNv^̍vj
			//				iCFG(9)+ACIF(9)+AC-HEAD(9)+AC-IT(12)+AC-OT(9)+
			//				  ASIF-ALT0(9)+ASIF-ALT1(9)+AS-GEN(7)+AS-FORM(11)+
			//				  EP(9)+AS-EP(7) = 100 = 0x64
	0x02,		//  bNumberIntefaces	: 0x02	iC^[tF[X͓			j
	0x01,		//  bConfigurationValue	: 0x01	iRtBO[V͈Ȃ̂ŁP̂	j
	0x00,		//  iConfiguration	: 0x00	igpj
	0x80,		//  bmAttributes	: 0x80	ioXp[foCXA[gEFCNAbvj
	0x64		//  MaxPower		: 100	idB200mAj
};

//
//@C^[tF[XEfBXNv^
//
unsigned char interface_desc[3][9] = {
{			//C^[tF[X0iAudio Controlj
	0x09,		//  bLength		: 0x09
	0x04,		//  bDescriptorType	: 0x04	iC^[tF[XEfBXNv^		j
	0x00,		//  bInterfaceNumber	: 0x00	iC^[tF[X0				j
	0x00,		//  bAlternateSetting	: 0x00	iI^l[gZbg͖			j
	0x00,		//  bNumEndpointes	: 0x00	iGh|Cg͎gȂ			j
	0x01,		//  bInterfaceClass	: 0x01	iAUDIO C^[tF[X			j
	0x01,		//  bInterfaceSubClass	: 0x01	iAUDIO_CONTROL					j
	0x00,		//  bInterfaceProtocol	: 0x00	iɂOO					j
	0x00		//  iInterface		: 0x00	igp					j
}, {			//C^[tF[X1iAudio StreamjAlternate #0 (Idle)
	0x09,		//  bLength		: 0x09
	0x04,		//  bDescriptorType	: 0x04	iC^[tF[XEfBXNv^		j
	0x01,		//  bInterfaceNumber	: 0x01	iC^[tF[X1				j
	0x00,		//  bAlternateSetting	: 0x00	iI^l[gZbg#0				j
	0x00,		//  bNumEndpointes	: 0x00	iGh|Cg͎gȂ			j
	0x01,		//  bInterfaceClass	: 0x01	iAUDIO C^[tF[X			j
	0x02,		//  bInterfaceSubClass	: 0x02	iAUDIO_STREAMING				j
	0x00,		//  bInterfaceProtocol	: 0x00	iɂOO					j
	0x00		//  iInterface		: 0x00	igp					j
}, {			//C^[tF[X1iAudio StreamjAlternate #1 (Active)
	0x09,		//  bLength		: 0x09
	0x04,		//  bDescriptorType	: 0x04	iC^[tF[XEfBXNv^		j
	0x01, 		//  bInterfaceNumber	: 0x01	iC^[tF[X1				j
	0x01,		//  bAlternateSetting	: 0x01	iI^l[gZbg#1				j
	0x01,		//  bNumEndpointes	: 0x01	iGh|Cg͈iAS-OUT)			j
	0x01,		//  bInterfaceClass	: 0x01	iAUDIO C^[tF[X			j
	0x02,		//  bInterfaceSubClass	: 0x02	iAUDIO_STREAMING				j
	0x00,		//  bInterfaceProtocol	: 0x00	iɂOO					j
	0x00		//  iInterface		: 0x00	igp					j
} };

// I[fBINXACC^[tF[XfBXNv^
//
unsigned char ac_ifdesc[9] = {
	0x09,		// bLength		: 0x09
	0x24,		// bDescriptorType	: 0x24	iAUDIO_INTERFACEfBXNv^			j
	0x01,		// bDescriptorSubType	: 0x01	iHEADER					j
	0x00, 0x01,	// bcdADC		: 0x0100iVersion1.0					j
	0x1e, 0x00,	// wTotalLength		: 0x001eiHEAD(9)+IT(12)+OT(9)=30			j
	0x01,		// bInCollection	: 0x01	iI[fBIXg[͈		j
	0x01		// baInterfaceNr(1)	: 0x01	iŏ̃I[fBIXg[~OIF͂P	j
};

// I[fBINXACC^[tF[XfBXNv^iInput Terminalj
//
// bLength		: 0x0c
// bDescriptorType	: 0x24	iAUDIO_INTERFACEfBXNv^			j
// bDescriptorSubType	: 0x02	iINPUT_TERMINAL				j
// bTerminalID		: 0x01	iInputTerminalPԂ̃^[~iɂ	j
// wTerminalType	: 0x0101iUSBXg[					j
// bAssocTerminal	: 0x00	iAssociate^[~i͖			j
// bNrChannels		: 0x02	i_`l2`l			j
// bChannelConfig	: 0x0003iLeft/Right					j
// iChannelNames	: 0x00	igp					j
// iTerminal		: 0x00	igp					j
unsigned char ac_itdesc[0x0c] = {
 0x0c, 0x24, 0x02, 0x01, 0x01,0x01, 0x00, 0x02, 0x03,0x00, 0x00, 0x00
};

// I[fBINXACC^[tF[XfBXNv^iOutput Terminalj
//
// bLength		: 0x09
// bDescriptorType	: 0x24	iAUDIO INTERFACEfBXNv^			j
// bDescriptorSubType	: 0x03	iOUTPUT_TERMINAL				j
// bTerminalID		: 0x02	iOUTPUT^[~i͂QԂɂ			j
// wTerminalType	: 0x0304iDesktop Speaker				j
// bAssocTerminal	: 0x00	iAssociate^[~i͖			j
// bSourceID		: 0x01	i\[XINPUT_TERMINAL			j
// iTerminal		: 0x00	igp					j
unsigned char ac_otdesc[9] = {
 0x09, 0x24, 0x03, 0x02, 0x04, 0x03, 0x00, 0x01, 0x00
};


// I[fBINXGENERALC^[tF[XfBXNv^
//
// bLength		: 0x07
// bDescriptorType	: 0x24	iAUDIO_INTERFACEfBXNv^			j
// bDescriptorSubType	: 0x01	iGENERALfBXNv^				j
// bTerminalLink	: 0x01	iGh|CgƌĂ^[~íP	j
// bDelay		: 0x01@ifBCPt[				j
// wFormatTag		: 0x0001iPCMtH[}bgFPCM8Ȃ0x0002		j
unsigned char as_gendesc[7] = {
 0x07, 0x24, 0x01, 0x01, 0x01, 0x01, 0x00
};

// I[fBINXTYPE-ItH[}bg^CvfBXNv^
// bLength		: 0x0b
// bDescriptorType	: 0x24	iAUDIO_INTERFACEfBXNv^			j
// bDescriptorSubType	: 0x02	iFORMAT_TYPEfBXNv^			j
// bFormatType		: 0x01	iFORMAT_TYPE1					j
// bNrChannels		: 0x02	i`l2				j
// bSubFrameSize	: 0x04	iP̃Tut[ŏ̂4oCg	j
// bBitResolution	: 0x10	iPUrbgI[fBI				j
// bSamFreqType		: 0x01	iTvO[g͂PiŒj		j
// bSamFreq		: 0x003e80(=16000=16KHz					j
unsigned char as_formdesc[0x0b] = {
//  0x0b, 0x24, 0x02, 0x01, 0x02, 0x04, 0x10, 0x01, 0x40, 0x1f, 0x00
  0x0b, 0x24, 0x02, 0x01, 0x02, 0x04, 0x10, 0x01, 0x80, 0x3e, 0x00
};

// Gh|CgfBXNv^
//
// bLength		: 0x09
// bDescriptorType	: 0x05	iGh|CgfBXNv^			j
// bEndpointAddress	: 0x02	iOUTAGh|CgAhXQ		j
// bAttributes		: 0x05	i񓯊AC\NiX				j
// wMaxPacketize	: 0x0080iISOOUT[h=128oCg			j
// bInterval		: 0x01	iAC\NiXł͏ɂP			j
// bRefresh		: 0x00	iɂOO					j
// bSynchAddress	: 0x00	ipCv͎gȂ̂łOO		j
unsigned char endpoint_desc[9] = {
 0x09, 0x05, 0x02, 0x05, 0x80, 0x00, 0x01, 0x00, 0x00
};

// I[fBINX`rAC\NiXGh|CgfBXNv^
//
// bLength		: 0x07
// bDescriptorType	: 0x25	iAUDIO_ENDPOINTfBXNv^			j
// bDescriptorSubType	: 0x01	iEP_GENERAL					j
// bmAttribute		: 0x00	iTvOgsb`䖳		j
// bLockDelayUnits	: 0x00	igp					j
// wLockDelay		: 0x0000igp					j

unsigned char as_epdesc[0x07] = {
 0x07, 0x25, 0x01, 0x00, 0x00, 0x00, 0x00
};

/*
   ***************************************************************************
   ** USB standard device requests
   ***************************************************************************
*/

void
set_address()
{
	unsigned char addr;
	addr = ControlData.DeviceRequest.wValue & DEVICE_ADDRESS_MASK;
	D12_SetAddressEnable(addr, 1);
	single_transmit(0, 0);
}

static unsigned char *dscpy( unsigned char *ptr, const void *src, int len )
{
	memcpy( ptr, src, len );
	return ptr+len;
}

void
get_descriptor(void)
{
	unsigned char bDescriptor = MSB(ControlData.DeviceRequest.wValue);

	if (bDescriptor == USB_DEVICE_DESCRIPTOR_TYPE) {
		code_transmit(dev_desc, sizeof dev_desc);
	} else if (bDescriptor == USB_CONFIGURATION_DESCRIPTOR_TYPE) {
		unsigned char *p = tmpbuff;
		p = dscpy(p, config_desc, sizeof config_desc);
		p = dscpy(p, interface_desc[0], sizeof interface_desc[0]);
		p = dscpy(p, ac_ifdesc, sizeof ac_ifdesc);
		p = dscpy(p, ac_itdesc, sizeof ac_itdesc);
		p = dscpy(p, ac_otdesc, sizeof ac_otdesc);
		p = dscpy(p, interface_desc[1], sizeof interface_desc[1]);
		p = dscpy(p, interface_desc[2], sizeof interface_desc[2]);
		p = dscpy(p, as_gendesc, sizeof as_gendesc);
		p = dscpy(p, as_formdesc, sizeof as_formdesc);
		p = dscpy(p, endpoint_desc, sizeof endpoint_desc);
		p = dscpy(p, as_epdesc, sizeof as_epdesc);
		code_transmit(tmpbuff, p - tmpbuff);
	} else {
		stall_ep0();
	}
}

void
get_configuration()
{
	unsigned char c = bEPPflags.bits.configuration;
	single_transmit(&c, 1);
}

void
set_configuration()
{
	if (ControlData.DeviceRequest.wValue == 0) {
		/* put device in unconfigured state */
		single_transmit(0, 0);
		DISABLE;
		bEPPflags.bits.configuration = 0;
		ENABLE;
		init_unconfig();
	} else if (ControlData.DeviceRequest.wValue == 1) {
		/* Configure device */
		single_transmit(0, 0);

		init_unconfig();
		init_config();
		
		DISABLE;
		bEPPflags.bits.configuration = 1;
		ENABLE;
	} else {
		stall_ep0();
	}
}

void
get_interface()
{
	unsigned char txdat = 0;        /* Only/Current interface = 0 */
	single_transmit(&txdat, 1);
}

void
set_interface()
{
	if(ControlData.DeviceRequest.wIndex == 1) {
		if(ControlData.DeviceRequest.wValue == 0) {
		} else {
		}
	}
	single_transmit(0, 0);
}
