#include <clip.h>

#include "d12ci.h"
#include "mainloop.h"
#include "usb100.h"
#include "chap_9.h"

/**************************************************/
int aaa, bbb, ccc;

#define N_WCHUNKS	32
#define WLEN		512
typedef struct _WCHUNK {
	PCEWAVEINFO info;
	short data[WLEN];
} WCHUNK;
WCHUNK wchunks[N_WCHUNKS];
WCHUNK* wc_cur;
void endproc(PCEWAVEINFO* wi) { wi->stat = 0; }
/**************************************************/

void usb_isr();
void fn_usb_isr();
void bus_reset();
void dma_eot();
void suspend_change();
void ep0_txdone(int st);
void ep0_rxdone(int st);
void ep1_txdone(int st);
void ep1_rxdone(int st);
void ep2_txdone(int st);
void ep2_rxdone(int st);

/****************************************************************************
 *	萔
 ****************************************************************************/

/* WfoCXNGXg */
void (*StandardDeviceRequest[])() = {
	stall_ep0/*get_status ... Ȃ݂*/,
	stall_ep0/*clear_feature ... Ȃ݂*/,
	stall_ep0,
	stall_ep0/*set_feature ... Ȃ݂*/,
	stall_ep0,
	set_address,
	get_descriptor,
	stall_ep0,
	get_configuration,
	set_configuration,
	get_interface,
	set_interface,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0
};

/* NXNGXg */
void (*ClassDeviceRequest[])() = {
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0
};

/* x_NGXg */
void (*VendorDeviceRequest[])() = {
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0,
	stall_ep0
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

EPPFLAGS bEPPflags;
CONTROL_XFER ControlData;

/****************************************************************************
 *	֐
 ****************************************************************************/

void
usb_isr()
{
	/* 荞ݏ[`̖{̂ĂяołB
	 * X^bN킹Kv̂ŁAGȏĂ͂܂B
	 * (Öق)[JϐāAX^bN鋰ꂪ܂B
	 */
	INT_BEGIN2;
	/*ENABLE; d荞݂ƂȂ~܂B*/
	bINT_FK01_FP03_FP1 = 0; /* 荞݃Rg[̗vtONA */
	fn_usb_isr();
	INT_END2;
}

void
fn_usb_isr()
{
	int st;

	/* 荞ݗv擾ENA܂B */
	st = D12_ReadInterruptRegister();

	/* oXZbgȂ瑼̗v͖܂B */
	if(st & D12_INT_BUSRESET) {
		bus_reset();
	/* oXZbgȊO̗v܂B */
	} else {
		if(st & D12_INT_SUSPENDCHANGE) suspend_change();
		if(st & D12_INT_EOT) dma_eot();
		/* D12_ReadLastTransactionStatus()ŁA]tONA܂B */
		if(st & D12_INT_ENDP0OUT) ep0_rxdone(D12_ReadLastTransactionStatus(0));
		if(st & D12_INT_ENDP0IN ) ep0_txdone(D12_ReadLastTransactionStatus(1));
		if(st & D12_INT_ENDP1OUT) ep1_rxdone(D12_ReadLastTransactionStatus(2));
		if(st & D12_INT_ENDP1IN ) ep1_txdone(D12_ReadLastTransactionStatus(3));
		if(st & D12_INT_ENDP2OUT) ep2_rxdone(D12_ReadLastTransactionStatus(4));
		if(st & D12_INT_ENDP2IN ) ep2_txdone(D12_ReadLastTransactionStatus(5));
	}
}

void
bus_reset()
{
}

void
suspend_change()
{
}

void
dma_eot()
{
}

int control_state;

void
ep0_rxdone(int st)
{
	int retval;

	if(st & D12_SETUPPACKET) {
		/* ܂AChԂɂĂ܂B */
		control_state = USB_IDLE;

		/* foCXNGXgǂݍ݂܂B */
		retval = D12_ReadEndpoint(0, &ControlData.DeviceRequest, sizeof(DEVICE_REQUEST));
		if(retval != sizeof(DEVICE_REQUEST)) {
			stall_ep0();
			return;
		}

		/* SETUPɂGh|Cg0~Ă̂ŁAA܂B */
		D12_AcknowledgeSetup(0);
		D12_AcknowledgeSetup(1);

		/* ǉf[^̓]TCY܂B */
		ControlData.wLength = ControlData.DeviceRequest.wLength;
		ControlData.wCount = 0;
		if(ControlData.DeviceRequest.bmRequestType & USB_ENDPOINT_DIRECTION_MASK) {
			/* GET_ */
			control_handler();
		} else {
			/* SET_ */
			if(ControlData.DeviceRequest.wLength == 0) {
				/* ǉf[^͂Ȃ̂ŁAɃfoCXNGXg܂B */
				control_handler();
			} else {
				/* ǉf[^ǂݍ񂾌ɁAfoCXNGXg܂B */
				if(ControlData.DeviceRequest.wLength > MAX_CONTROLDATA_SIZE) {
					stall_ep0();
					return;
				}
				control_state = USB_RECEIVE;
			}
		}
		return;
	}

	if(control_state == USB_RECEIVE) {
		/* ǉf[^̓ǂݍ݂AfoCXNGXg܂B */
		retval = D12_ReadEndpoint(0, ControlData.dataBuffer + ControlData.wCount, ControlData.wLength - ControlData.wCount);
		ControlData.wCount += retval;
		if(ControlData.wCount == ControlData.wLength) {
			control_state = USB_IDLE;
			control_handler();
		}
		return;
	}

	/* ԂXe[^XXe[W̎MB
	 * SETUPMŃobt@͎IɃtbV̂ŁAIɋɂĂKv͂܂B
	 */
}

void
ep0_txdone(int st)
{
	int len;

	if(control_state != USB_TRANSMIT) return; /* ԂXe[^XXe[W̑M */

	/* ǉf[^𑗐M܂B */
	len = ControlData.wLength - ControlData.wCount;
	if(len > EP0_PACKET_SIZE) len = EP0_PACKET_SIZE;
	D12_WriteEndpoint(1, ControlData.pData + ControlData.wCount, len);
	ControlData.wCount += len;
	if(len < EP0_PACKET_SIZE) control_state = USB_IDLE;
}

void
ep1_rxdone(int st)
{
}

void
ep1_txdone(int st)
{
}

void
ep2_rxdone(int st)
{
	WCHUNK* wc;

	short buf[128 / 2], *src, *dst, lf, ri;
	int i, len;

	len = D12_ReadEndpoint(4, buf, sizeof buf);
	len /= 4; /* 16bit,stereo */
	if(len == 0) return;

ccc++;
	if(wc_cur == NULL) {
		for(i = 0; i < N_WCHUNKS; i++) {
			if(!wchunks[i].info.stat) break;
		}
		if(i == N_WCHUNKS) {
			pceWaveAbort(0);
			memset(wchunks, 0, sizeof wchunks);
			return;
		}
aaa = i;
bbb++;
		wc_cur = &wchunks[i];
		memset(&wc_cur->info, 0, sizeof(PCEWAVEINFO));
		wc_cur->info.stat = 1;
		wc_cur->info.type = PW_TYPE_16BITPCM | PW_TYPE_CONT;
		wc_cur->info.pData = wc_cur->data;
		wc_cur->info.pfEndProc = endproc;
	}
	wc = wc_cur;

	src = buf;
	dst = wc->data + wc->info.len;
	for(i = 0; i < len; i++) {
		lf = *src++;
		ri = *src++;
		*dst++ = (lf + ri) / 2;
		if(++wc->info.len == WLEN) {
			pceWaveDataOut(0, &wc_cur->info);
			wc_cur = NULL;
			break;
		}
	}
}

void
ep2_txdone(int st)
{
}

/****************************************************************************
 *	֐
 ****************************************************************************/

void
stall_ep0()
{
	D12_SetEndpointStatus(0, 1);
	D12_SetEndpointStatus(1, 1);
}

void
init_unconfig()
{
	D12_SetEndpointEnable(0);
}

void
init_config()
{
	D12_SetEndpointEnable(1);
}

void
single_transmit(unsigned char* buf, unsigned char len)
{
	if(len > EP0_PACKET_SIZE) return;
	D12_WriteEndpoint(1, buf, len);
}

void
code_transmit(unsigned char* pRomData, unsigned short len)
{
	ControlData.wCount = 0;
	if(ControlData.wLength > len) ControlData.wLength = len;

	ControlData.pData = pRomData;
	if(ControlData.wLength >= EP0_PACKET_SIZE) {
		D12_WriteEndpoint(1, ControlData.pData, EP0_PACKET_SIZE);
		ControlData.wCount += EP0_PACKET_SIZE;
		control_state = USB_TRANSMIT;
	} else {
		D12_WriteEndpoint(1, pRomData, ControlData.wLength);
		ControlData.wCount += ControlData.wLength;
		control_state = USB_IDLE;
	}
}

void
control_handler()
{
	int type, req;

	type = ControlData.DeviceRequest.bmRequestType & USB_REQUEST_TYPE_MASK;
	req  = ControlData.DeviceRequest.bRequest      & USB_REQUEST_MASK;

	switch(type) {
	case USB_STANDARD_REQUEST:
		StandardDeviceRequest[req]();
		break;
	case USB_CLASS_REQUEST:
		ClassDeviceRequest[req]();
		break;
	case USB_VENDOR_REQUEST:
		VendorDeviceRequest[req]();
		break;
	default:
		stall_ep0();
		break;
	}
}

/****************************************************************************
 *	֐
 ****************************************************************************/

PCEKSENT old_usb_isr;

void
hook_USB()
{
	/* USBؒfB */
	D12_SetMode(0, D12_SETTOONE);

	/* PCؒfoł悤ɁAEFCgB */
	usleep(200 * 1000);

	/* USBC荞݂tbNB */
	old_usb_isr = pceVectorSetTrap(17, usb_isr);

	/* USBڑB */
	D12_SetMode(D12_ENDP_ISOIO | D12_SOFTCONNECT, D12_SETTOONE);
}

void
unhook_USB()
{
	/* USBؒfB */
	D12_SetMode(0, D12_SETTOONE);

	/* PCؒfoł悤ɁAEFCgB */
	usleep(200 * 1000);

	/* USBC荞݂ɖ߂B */
	pceVectorSetTrap(17, old_usb_isr);

	/* USBڑB */
	D12_SetMode(D12_SOFTCONNECT, D12_SETTOONE);
}

/****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];
int joy;

void
schedule()
{
	pceLCDTrans();
	yield();
	joy = pcePadGet();
}

void app_exit();

int
main()
{
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();

	pceWaveSetChAtt(0, 0);

	hook_USB();
	atexit(app_exit);

	for(;;) {
		schedule();
		if(joy & TRG_SELECT) break;
		memset(vbuff, 0, sizeof vbuff);
		pceFontSetPos(0, 0);
		pceFontPrintf("SEL{^ŏI܂B\n");
		pceFontPrintf("\n");
		pceFontPrintf("fobOF\n");
		pceFontPrintf("`N = %d\n", aaa);
		pceFontPrintf("Đ = %d\n", bbb);
		pceFontPrintf("M = %d\n", ccc);
	}

	return 0;
}

void
app_exit()
{
	unhook_USB();
	pceWaveStop(0);
}
